;8192 points accuracy DDS program with 12 bits DAC on SPI

;*************************************************
;*************************************************
;***                                           ***
;***  8192p DDS program with 12bits DAC        ***
;***                    on ATmega series       ***
;***                                           ***
;***  >output sine curve,rectangular wave,     ***
;***      triangle wave,sawtooth wave          ***
;***      via 12bits DAC on SPI                ***
;***  >frequency : 1Hz to 20000Hz (1Hz step)   ***
;***  >included 8192 points sine wave table    ***
;***      with timer interrupt                 ***
;***  >control via UART (with PC and so on)    ***
;***                                           ***
;***                                           ***
;***                        m.suga             ***
;***                        created 2011.4.14  ***
;***                                           ***
;*************************************************
;*************************************************



	;*******************
	;*****  `  *****
	;*******************

	;*****  `t@C  *****

.include "m328Pdef.inc"



	;*****  WX^  *****

	;R16 ` R25

.def data1 = R16			;Ǐpr̔ėpWX^1
.def data2 = R17			;Ǐpr̔ėpWX^2
.def out_data1 = R18		;SPIo͗pf[^8rbgiTunpj
.def out_data2 = R19		;SPIo͗pf[^8rbgiTunpj

.def count1 = R20			;ėpJE^P
.def count2 = R21			;ėpJE^Q

.def freq_l =r22			;g̃oCiliʁj
.def freq_h = r23			;g̃oCiliʁj



	;R0 ` R15

.def omega0 = r2			;pxւ̍ŉ
.def omega1 = r3			;
.def omega2 = r4			;
.def omega3 = r5			;pxւ̍ŏ

.def multiplier0 = r6		;搔
.def multiplier1 = r7		;搔

.def multiplicand0 = r8		;搔
.def multiplicand1 = r9		;搔


.def work1 = r10			;vZp[NP
.def work2 = r11			;vZp[NQ

.def w_omega0 = r12			;[Nppxւ̍ŉ
.def w_omega1 = r13			;
.def w_omega2 = r14			;
.def w_omega3 = r15			;[Nppxւ̍ŏ



	;*****  萔  *****



	;*****  }N`ǂݍ  *****

.include "multiply16.inc"




	;********************************
	;*****  荞݃xN^̐ݒ  *****
	;********************************

.org 0x0000				;Zbg̃X^[gԒn

	jmp	RESET		;Zbg̃Wv
	jmp RESET ; IRQ0 Handler
	jmp RESET ; IRQ1 Handler
	jmp RESET ; PCINT0 Handler
	jmp RESET ; PCINT1 Handler
	jmp RESET ; PCINT2 Handler
	jmp RESET ; Watchdog Timer Handler
	jmp INT_TM2 ; Timer2 Compare A Handler
	jmp RESET ; Timer2 Compare B Handler
	jmp RESET ; Timer2 Overflow Handler
	jmp TIM1_CAPT ; Timer1 Capture Handler
	jmp TIM1_COMPA ; Timer1 Compare A Handler
	jmp TIM1_COMPB ; Timer1 Compare B Handler
	jmp TIM1_OVF ; Timer1 Overflow Handler

	;̑̊荞݂͕sƂ



RESET:

	;***********************
	;*****    *****
	;***********************


	;*****  荞݋֎~  *****

	cli

	;*****  X^bN|C^ݒ  *****

	ldi		data1,high(RAMEND)		;data1ɃX^bN|C^̃AhXZbg
	out		SPH,data1			;X^bN|C^data1Zbg
	ldi		data1,low(RAMEND)		;data1ɃX^bN|C^̃AhXZbg
	out		SPL,data1			;X^bN|C^data1Zbg

	;*****  Ăяo  *****

	rcall	INITIALIZE





	;*************************
	;*****  C[v  *****
	;*************************

	;*****  荞݋  *****

	sei



MAIN_LOOP:

	;*****  UART̓`FbNƐݒύX  *****

	call	UART_CHECK


	rjmp	MAIN_LOOP		;߂







	;*************************
	;*****  Tu[`  *****
	;*************************


	;*****                 *****
	;*****    *****
	;*****                 *****
INITIALIZE:

	;*****  荞ݐݒ  *****


	ldi		data1,0b00000000
	out		EIMSK,data1			;INT0,INT1̊Oݕsɐݒ




	;*****  o̓|[g̐ݒ  *****

	ldi		data1,0b00101110	;PB5(SCK),PB3(MOSI),PB2(SS),PB1(LDAC)
								;̃rbg1
	out		DDRB,data1

	ldi		data1,0b00000000	;S͂
	out		DDRD,data1

	ldi		data1,0b00000000	;S͂
	out		DDRC,data1

	;***  CSiMCP4922ւ̃`bvZNg=HIGHj  ***

	sbi		PORTB,PB2			;SSIt
	sbi		PORTB,PB1			;LDAC=1ib`j



	;*****  RS232C@  *****

	ldi		data1,0
	sts		UCSR0B,data1		;܂AUfB[[uɐݒ
	ldi		data1,0				;U2Xn0ɐݒi_ugpj
	sts		UCSR0A,data1		;ׂăNA

	ldi		data1,((1<<UCSZ01)|(1<<UCSZ00))
	sts		UCSR0C,data1		;8rbgAmpAXgbvP

	ldi		data1,high(51)
	sts		UBRR0H,data1		;4rbg
	ldi		data1,low(51)
	sts		UBRR0L,data1		;8rbg
								;U2Xn=0,UBRRn = 51 (=19200bps @16MHz)
								;error = 0.2%

	ldi		data1,(1<<RXEN0)
	sts		UCSR0B,data1		;ݒ芮ɁAMCl[uݒ





	;*****  SPIW[̐ݒ  ******

	ldi		data1,(1<<SPE)|(1<<MSTR)
	out		SPCR,data1
						;SPI荞ݖASPIW[IA
						; MSB瑗oA}X^A[h0-0ANbN1/4

	ldi		data1,(1<<SPI2X)
	out		SPSR,data1
						;2{(1/4*2=NbN1/2)




	;*****  SRAM̏  ******

	ldi		zl,low(THETA)
	ldi		zh,high(THETA)		;ɊpxƂ̃AhXݒ

	ldi		data1,0
	ldi		count1,4			;SoCgJԂ
INITIALIZE_LOOP1:
	st		z+,data1
	dec		count1
	brne	INITIALIZE_LOOP1	;px̏lO


	ldi		zl,low(OMEGA)
	ldi		zh,high(OMEGA)		;Ɋpxւ̃AhXݒ

	ldi		data1,0
	ldi		count1,4			;SoCgJԂ
INITIALIZE_LOOP2:
	st		z+,data1
	dec		count1
	brne	INITIALIZE_LOOP2	;px̏lO


	ldi		zl,low(INPUT_BYTES)
	ldi		zh,high(INPUT_BYTES)	;ɓ͍ς݌̃AhXݒ

	st		z,data1				;͍ς݌̏lO


	ldi		zl,low(WAVE_FORM)
	ldi		zh,high(WAVE_FORM)	;ɔg`̃AhXݒ

	st		z,data1				;g`̏lg




	;*****  timer2̐ݒ  *****

	ldi		data1,0				;^C}[QU~
	sts		TCCR2B,data1

	ldi		data1,(1<<OCIE2A)
	sts		TIMSK2,data1		;^C}QI[o[t[ݗL

	ldi		data1,200-1			;snolQOO
	sts		OCR2A,data1			;AEgvbgRyAWX^`
								;16Mhz1200 = 80000hz

	ldi		data1,(1<<WGM21)
	sts		TCCR2A,data1		;timer2[hQŎgp
								;ibsb[hAsnolOCR2Aj
								;OC2A,OC2B͔ڑim[}|[gj

	ldi		data1,(1<<CS20)		;NbN\[XvXP[
	sts		TCCR2B,data1		;^C}[QX^[g



	ret							;I





	;*****                          *****
	;*****  UART͂ƐݒύX  *****
	;*****                          *****
UART_CHECK:



	;***  UART͗L`FbN  ***

	lds		data1,UCSR0A
	andi	data1,(1<<RXC0)
	brne	UART_CHK1			;ǃf[^H
	jmp		UART_RET			;ȂΖ߂



	;***  ̓f[^ʂ̏U蕪ilEjƃXe[^XǗ  ***
UART_CHK1:
	lds		data1,UDR0			;PoCgǂݏo

	cpi		data1,'0'
	brcc	UART_CHK2
	jmp		UART_OTHER			;'0'菬ꍇ͑ΏۊO
UART_CHK2:
	cpi		data1,('9'+1)
	brcs	UART_NUM			;'0'`'9'Ȃ琔lƂď
	jmp		UART_LETTER			;̑͂Ƃ肠pƉ肵ĐU蕪



	;***  l͎̏  ***
UART_NUM:
	subi	data1,'0'			;UART͕̓𐔒lɕϊ

	ldi		zl,low(INPUT_BUF+5)
	ldi		zh,high(INPUT_BUF+5)
	ldi		xl,low(INPUT_BUF+4)
	ldi		xh,high(INPUT_BUF+4)
	ldi		count1,5-1
UART_NUM_LOOP1:
	ld		data2,-x
	st		-z,data2
	dec		count1
	brne	UART_NUM_LOOP1		;T̃obt@ɂPoCgVtgĂ

	st		-z,data1			;͒lԉEiŉʁjɊi[

	ldi		zl,low(INPUT_BYTES)
	ldi		zh,high(INPUT_BYTES)
	ld		data1,z
	inc		data1
	cpi		data1,6				;Uڂ̓͂H
	brne	UART_NUM_CHK1
	ldi		data1,5				;IɂTɊۂ߂iÂUڂ؂̂Ĉj
UART_NUM_CHK1:
	st		z,data1
	jmp		UART_RET			;i[߂



	;***  ̏  ***
UART_LETTER:

	cpi		data1,('Z'+1)
	brcs	UART_LETTER_CHK0
	subi	data1,('a'-'A')		;͈̔͂ɂꍇA܂啶ɕϊ

UART_LETTER_CHK0:
	cpi		data1,'F'
	brne	UART_LETTER_CHK1
	jmp		UART_CALC_OMEGA		;'F'Ȃgpxւ̕ϊ

UART_LETTER_CHK1:
	cpi		data1,'W'
	brne	UART_LETTER_CHK2
	jmp		UART_WAVE_FORM		;'W'Ȃg`ύX

UART_LETTER_CHK2:
	cpi		data1,'R'
	brne	UART_LETTER_CHK3
	jmp		RESET				;'R'Ȃ烊ZbgiċNj

UART_LETTER_CHK3:
	jmp		UART_OTHER			;̑ȂΏۊO



	;***  ΏۊȌꍇ̏  ***
UART_OTHER:

	ldi		zl,low(INPUT_BYTES)
	ldi		zh,high(INPUT_BYTES)
	ldi		data2,0				;͍ςݐl̐IɂONA
	st		z,data2

	jmp		UART_RET				;obt@NAԂ̈ƂĖ߂



	;***  gpxւ̕ϊ  ***
								;***  ܂͍ς݂5ȓ̐l10ioCi
								;***  20000Hz𒴂Ăꍇ20000Hz
								;***  gpxZoie16rbgj
UART_CALC_OMEGA:

	ldi		zl,low(INPUT_BYTES)
	ldi		zh,high(INPUT_BYTES)
	ld		count1,z			;͍ςݐľǂݏo

	ldi		data1,0

	ldi		zl,low(INPUT_BUF)
	ldi		zh,high(INPUT_BUF)	;ɐl̓obt@ݒ
	add		zl,count1
	adc		zh,data1			;炷

	neg		count1
	subi	count1,(-5)			;count1  (5 - count1) ݒ
	breq	UART_CALC_OMEGA_CHK0	;[NAsp̏ꍇXLbviTS͂j
UART_CALC_OMEGA_LOOP1:
	st		z+,data1
	dec		count1
	brne	UART_CALC_OMEGA_LOOP1	;͍ς݂̌̌ɂĂ͂ONAĂ

UART_CALC_OMEGA_CHK0:
	clr		freq_l
	clr		freq_h				;gioCiljNAĂ
	ldi		zl,low(INPUT_BUF+5)
	ldi		zh,high(INPUT_BUF+5)	;ɐl̓obt@̍ŏ㌅̂Pݒ

	ldi		count1,5
UART_CALC_OMEGA_LOOP2:
	add		freq_l,freq_l
	adc		freq_h,freq_h		;Q{

	mov		work1,freq_l
	mov		work2,freq_h		;Uޔ

	add		freq_l,freq_l
	adc		freq_h,freq_h		;S{

	add		freq_l,freq_l
	adc		freq_h,freq_h		;W{

	add		freq_l,work1
	adc		freq_h,work2		;PO{

	ld		data2,-z			;Pɓǂݏo
	add		freq_l,data2
	adc		freq_h,data1		;ŏɑ

	dec		count1				;TJԂ
	brne	UART_CALC_OMEGA_LOOP2


	ldi		data1,low(20000)
	ldi		data2,high(20000)
	cp		freq_l,data1
	cpc		freq_h,data2
	brcs	UART_CALC_OMEGA_CHK1
	mov		freq_l,data1
	mov		freq_h,data2		;͂ꂽl20000Hz𒴂Ăꍇ20000Hz

UART_CALC_OMEGA_CHK1:
								;16*16rbg|ZiPʊpx̌vZj
								;  ( (65536 * 8192 / 20000*4) ~ freq ) -> omega

	ldi		data1,low(65536*8192/80000+1)		;i؂グ덷17ppmj
	mov		multiplicand0,data1
	ldi		data1,high(65536*8192/80000+1)		;i؂グ덷17ppmj
	mov		multiplicand1,data1			;搔i萔j

	mov		multiplier0,freq_l
	mov		multiplier1,freq_h			;搔igj

	multiply16	multiplicand0,multiplicand1,multiplier0,multiplier1,w_omega0,w_omega1,w_omega2,w_omega3



	cli
	mov		omega0,w_omega0
	mov		omega1,w_omega1
	mov		omega2,w_omega2
	mov		omega3,w_omega3		;px̕ύXiAg~bNANZXj
	sei


	ldi		zl,low(INPUT_BYTES)
	ldi		zh,high(INPUT_BYTES)
	ldi		data2,0				;͍ςݐl̐IɂONA
	st		z,data2


	jmp	UART_RET				;obt@NAԂ̈ƂĖ߂




	;***  g`ύX  ***
UART_WAVE_FORM:

	ldi		zl,low(INPUT_BYTES)
	ldi		zh,high(INPUT_BYTES)
	ld		data2,z			;͍ς݌ǂݏo
	
	cpi		data2,0
	brne	UART_WAVE_FORM_CHK1
	ldi		data2,0			;͍ς݂݂̐Ȃꍇ͔g`Oigj
	jmp		UART_WAVE_FORM_CHK2

UART_WAVE_FORM_CHK1:
	ldi		zl,low(INPUT_BUF)
	ldi		zh,high(INPUT_BUF)
	ld		data2,z			;͍ς݂̐Pȏ㑶݂ꍇ͍Ō̐liŏjKp

	cpi		data2,4+1		;S𒴂ĂȂmF
	brcs	UART_WAVE_FORM_CHK2
	ldi		data2,0			;S𒴂Ăꍇ͔g`Oigj

UART_WAVE_FORM_CHK2:
	ldi		zl,low(WAVE_FORM)
	ldi		zh,high(WAVE_FORM)
	st		z,data2			;g`̌`ۑ

	ldi		zl,low(INPUT_BYTES)
	ldi		zh,high(INPUT_BYTES)
	ldi		data2,0			;͍ςݐl̐IɂONA
	st		z,data2

	jmp	UART_RET			;߂



	;***  Cɖ߂  ***
UART_RET:
	ret							;߂





	;*****                                *****
	;*****  ^C}[QRyA}b`  *****
	;*****                                *****
INT_TM2:
	;***  荞ݒŎgp郌WX^ނ̑ޔ  ***

	push	data1
	in		data1,SREG
	push	data1
	push	data2
	push	zl
	push	zh



	;***  荞ݏԕ  ***
									;^C}[2荞݂ŌĂяoB
									;ݒ肳ĂpxƂɁA
									;Ăяo_̎ɂpxZoA
									;eg`isine[uǂݏoȂǁj̎Zo
									;DACɏo͂

	;***  px̍XVƏ  ***
	ldi		zl,low(THETA)
	ldi		zh,high(THETA)

	ld		data1,z
	add		data1,omega0
	st		z+,data1
	ld		data1,z
	adc		data1,omega1
	st		z+,data1
	ld		data1,z
	adc		data1,omega2
	st		z+,data1
	ld		data1,z
	adc		data1,omega3
	st		z+,data1


	;***  w肳ꂽg`Ƃ̐U蕪ƒl̎Zo  ***
	ldi		zl,low(WAVE_FORM)
	ldi		zh,high(WAVE_FORM)

	ld		data1,z+

	cpi		data1,0
	breq	INT_TM2_SIN
	cpi		data1,1
	breq	INT_TM2_SQ
	cpi		data1,2
	breq	INT_TM2_TR
	cpi		data1,3
	breq	INT_TM2_SW1
	jmp 	INT_TM2_SW2


	;***  sing̏o  ***
INT_TM2_SIN:
	ldi		zl,low(THETA+2)
	ldi		zh,high(THETA+2)	;px̐

	ld		data1,z+
	ld		data2,z+			;pxǂݏo
	andi	data2,0x1f			;O`WPXPɊۂ߂

	ldi		zl,low(SINE8192TABLE*2)
	ldi		zh,high(SINE8192TABLE*2)

	add		zl,data1
	adc		zh,data2
	add		zl,data1
	adc		zh,data2			;ʑiւ̐2{j炷


	lpm		out_data1,z+
	lpm		out_data2,z+		;sine[uŸʑf[^ǂݏo

	call	OUT_SPI

	jmp		INT_TM2_RET


	;***  `g̏o  ***
INT_TM2_SQ:
	ldi		zl,low(THETA+2)
	ldi		zh,high(THETA+2)	;px̐

	ld		data1,z+
	ld		data2,z+			;pxǂݏo
	andi	data2,0x1f			;O`WPXPɊۂ߂

	lsr		data2
	ror		data1				;VtgĂO`SOXTɎ߂

	ldi		out_data1,0
	ldi		out_data2,0		;Uo͒lO(low-value)ɂĂ

	cpi		data1,low(4096/2)
	ldi		data1,high(4096/2)
	cpc		data2,data1
	brcs	INT_TM2_SQ_CHK1

	ldi		out_data1,low(0x0fff)
	ldi		out_data2,high(0x0fff)	;ɎĂȂꍇhigh-valueo
INT_TM2_SQ_CHK1:

	call	OUT_SPI

	jmp		INT_TM2_RET


	;***  Opg̏o  ***
INT_TM2_TR:
	ldi		zl,low(THETA+2)
	ldi		zh,high(THETA+2)	;px̐

	ld		data1,z+
	ld		data2,z+			;pxǂݏo
	andi	data2,0x1f			;O`WPXPɊۂ߂

	ldi		out_data1,low(8192/2)
	ldi		out_data2,high(8192/2)
	cp		data1,out_data1
	cpc		data2,out_data2		;ɒBĂH
	brcc	INT_TM2_TR_CHK1

	mov		out_data1,data1
	mov		out_data2,data2		;BĂȂꍇ(px)
	jmp		INT_TM2_TR_CHK2

INT_TM2_TR_CHK1:

	ldi		out_data1,low(8191)
	ldi		out_data2,high(8191)
	sub		out_data1,data1
	sbc		out_data2,data2		;BĂꍇ(8191-px)


INT_TM2_TR_CHK2:
	call	OUT_SPI

	jmp		INT_TM2_RET


	;***  ̂g1̏o(^|^|^|)  ***
INT_TM2_SW1:
	ldi		zl,low(THETA+2)
	ldi		zh,high(THETA+2)	;px̐

	ld		data1,z+
	ld		data2,z+			;pxǂݏo
	andi	data2,0x1f			;O`WPXPɊۂ߂

	lsr		data2
	ror		data1				;VtgĂO`SOXTɎ߂
	mov		out_data1,data1
	mov		out_data2,data2

	call	OUT_SPI

	jmp		INT_TM2_RET


	;***  ̂g2̏o(|_|_|_)  ***
INT_TM2_SW2:
	ldi		zl,low(THETA+2)
	ldi		zh,high(THETA+2)	;px̐

	ld		data1,z+
	ld		data2,z+			;pxǂݏo
	andi	data2,0x1f			;O`WPXPɊۂ߂

	lsr		data2
	ror		data1				;VtgĂO`SOXTɎ߂

	ldi		out_data1,0xff
	ldi		out_data2,0x0f

	sub		out_data1,data1
	sbc		out_data2,data2		;o̓f[^(0x0fff-px)

	call	OUT_SPI

	jmp		INT_TM2_RET



	;***  ޔĂWX^ނ̕A  ***
INT_TM2_RET:
	pop		zh
	pop		zl
	pop		data2
	pop		data1
	out		SREG,data1
	pop		data1

	reti					;^C}[QݏI



TIM1_CAPT:
TIM1_COMPA:
TIM1_COMPB:
TIM1_OVF:
	reti





	;*****               *****
	;*****  SPIó  *****
	;*****               *****
OUT_SPI:
	
	;***  CSXg[u  ***

	cbi		PORTB,PB2


	;***  8rbgo  ***

	ori		out_data2,(1<<5)|(1<<4)
				;out on DAC-A,Vref buffered,gain*1,output buffer on
	out		SPDR,out_data2

	;***  ]܂ő҂  ***
OUT_SPI_LOOP1:
	in		data1,SPSR
	andi	data1,(1<<SPIF)
	breq	OUT_SPI_LOOP1

	;***  8rbgo  ***

	out		SPDR,out_data1

	;***  ]܂ő҂  ***
OUT_SPI_LOOP2:
	in		data1,SPSR
	andi	data1,(1<<SPIF)
	breq	OUT_SPI_LOOP2

	;***  CSXg[u  ***

	sbi		PORTB,PB2

	;***  LDACIt  ***

	cbi		PORTB,PB1			;LDACVN
	sbi		PORTB,PB1			;LDACb`


	ret




	;******************************
	;*****  e[uނ̒`  *****
	;******************************


	;*****  萔e[u@ǂݍ  *****

.cseg

SINE8192TABLE:

.include "sine8192.inc"



	;*****  S-RAM }bv`  *****

.dseg

INPUT_BUF:					;UART̓̓obt@
	.byte	5			;ToCgilf[^i[j

INPUT_BYTES:					;obt@Oς݃f[^oCg
	.byte	1			;PoCgilf[^i[j

WAVE_FORM:
	.byte	1			;PoCgig`̎ނi[j
						;@OFg
						;@PF`g
						;@QFOpg
						;@RFmRMgPi^|^|^|)
						;@SFmRMgQi|_|_|_)

THETA:
	.byte	4			;SoCgi_̈ʑj

OMEGA:
	.byte	4			;SoCgipxj

